//+------------------------------------------------------------------+
//|                                    Patrick's Expert Template.mq4 |
//|                                Copyright � 2006, InterbankFX llc |
//|                                       http://www.interbankfx.com |
//+------------------------------------------------------------------+
//                           Version 0.11 Written by Patrick Nouvion | 
//                                     Last update September 25 2006 |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                              COPYRIGHT                           |
//|               YOU SHOULD USE YOUR OWN COPYRIGHT HERE             |
//+------------------------------------------------------------------+
#property copyright "Copyright � 2006, InterbankFX llc"
#property link      "http://www.interbankfx.com"
//+------------------------------------------------------------------+
//|                        COMMON DECLARATION                        |
//|     YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS BOX        |
//+------------------------------------------------------------------+
datetime timeprev=0;
bool EnterLong = false;
bool ExitLong  = false;
bool EnterShort = false;
bool ExitShort = false;
bool TurnedUp = false;
bool TurnedDown = false;
//+------------------------------------------------------------------+
//|                          EXPERT COLORS                           |
//|            ADJUST THESE VALUES TO MATCH REQUIREMENTS             |
//+------------------------------------------------------------------+
//---- This is the name that will appear on the chart if the expert 
//---- is attached
static string      ExpertName = "Patricks Template";
//---- Enter Long Color
static color   EnterLongColor = Green;
//---- Enter Short Color
static color  EnterShortColor = Red;
//---- Exit Long Color
static color    ExitLongColor = Blue;
//---- Exit Short Color
static color   ExitShortColor = Pink;
//---- If using pending orders and if you need an expiration enter the value here
static int     EXPIRATION     = 0;

//+------------------------------------------------------------------+
//|                          EXPERT ID                               |
//+------------------------------------------------------------------+
// You need to give a unique id to each one of your expert
// This will be used as the magic number and then keep track of 
// the orders generated by the expert. 

//---- The expert ID has to be a 2 digit number followed by 0000
//---- For example: 550000 or 120000 etc ...
static int ExpertID = 660000;

//+------------------------------------------------------------------+
//|                           USER INPUT                             |
//|            ADJUST THESE VALUES TO MATCH REQUIREMENTS             |
//+------------------------------------------------------------------+
//|                Trading Inputs/Indicators Inputs                  |
//+------------------------------------------------------------------+
// If you do not need to use one of these inputs simply comment it out
// For example:
// extern bool Multiple entries = false;
 
extern double Lots = 1.0;
//---- Set stoploss to 0.0 if you don't want to use it
extern double StopLoss= 30.0;
//---- Set ProfitTarget to 0.0 if you don't want to use it
extern double ProfitTarget = 50.0;
//---- Set TrailingStop to 0.0 if you don't want to use it
extern double TrailingStop = 20.0;
//---- Slippage / Max deviation from quoted price
extern int    Slippage= 2;

//---- Do we want the expert to work accross all time frame 
//---- or just the currently selected time frame
extern bool   TimeSpecific = true;



// *************************************************INDICATOR*******************
// double ExtMapBuffer1[];
// double ExtMapBuffer2[];


// *************************************************END*************************





// Create any user input for the indicators you will use here
// For example:
//extern int Periods=14;
//extern int Deviation=2;

//+------------------------------------------------------------------+
//|                    EXPERT BASIC INITIALISATION                   |
//|     YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS BOX        |
//+------------------------------------------------------------------+
int start()

  {
     if(timeprev==Time[0]){return(0);}
     timeprev = Time[0];
     
     int MagicNumber = 0;
     MagicNumber = MakeMagicNumber( ExpertID, TimeSpecific );
     
     EnterLong = false;
     ExitLong  = false;
     EnterShort = false;
     ExitShort = false;
     
     TrailingAlls(0,TrailingStop);
//+------------------------------------------------------------------+
//|                    EXPERT BASIC CALCULATION                      |
//|                          START HERE                              |
//+------------------------------------------------------------------+


 iCustom(Symbol(),"postfin",0,TurnedUp,0,0,0);
 iCustom(Symbol(),"postfin",0,TurnedDown,0,0,0);
 
//EnterLong = TurnedUp;
// EnterShort = TurnedDown;




// EnterLong = true;
// if( TurnedUp == true ) EnterLong== true;
// EnterShort = TurnedDown;
//}
//if(icustom(Symbol(), "postfin","TurnedUp",0,0) == True  && EnterLong== 1 )
//{



//+------------------------------------------------------------------+
//|                    EXPERT BASIC CALCULATION                      |
//|                          END HERE                                |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|     YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS BOX        |
//+------------------------------------------------------------------+

// ENTER LONG CONDITION
if(EnterLong == true && CountLongs(MagicNumber)== 0)
{
   //CLOSE OPEN ORDER
   CloseShorts(MagicNumber);
   // PLACE THE ORDER
   OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(Bid,StopLoss),TakeLong(Ask,ProfitTarget),ExpertName,MagicNumber,EXPIRATION,EnterLongColor);
} 
// ENTER SHORT CONDITION
if(EnterShort == true && CountShorts(MagicNumber)== 0)
{
   //CLOSE OPEN ORDER
   CloseLongs(MagicNumber);
   // PLACE THE ORDER
   OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopShort(Ask,StopLoss),TakeShort(Bid,ProfitTarget),ExpertName,MagicNumber,EXPIRATION,EnterShortColor);
} 
if(ExitLong == true && CountLongs(MagicNumber)== 1)
{
   //CLOSE OPEN ORDER
   CloseLongs(MagicNumber);
}
if(ExitShort == true && CountShorts(MagicNumber)== 1)
{
   //CLOSE OPEN ORDER
   CloseShorts(MagicNumber);
}
   return(0);
 }
//+------------------------------------------------------------------+
//|                     EXTERNAL FUNCTIONS                           |
//|     YOU SHOULD NOT HAVE TO MODIFY ANYTHING BELOW THIS BOX        |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Make Magic Number                                                |
//+------------------------------------------------------------------+
int MakeMagicNumber( int ExpertID, bool TimeSpecific )
{
   int SymbolCode  = 0;
   int PeriodCode  = 0;
   int MagicNumber = 0; 
   
   //---- Symbol Code
        if( Symbol() == "AUDCAD" || Symbol() == "AUDCADm" ) { SymbolCode = 1000; }
   else if( Symbol() == "AUDJPY" || Symbol() == "AUDJPYm" ) { SymbolCode = 2000; }
   else if( Symbol() == "AUDNZD" || Symbol() == "AUDNZDm" ) { SymbolCode = 3000; }
   else if( Symbol() == "AUDUSD" || Symbol() == "AUDUSDm" ) { SymbolCode = 4000; }
   else if( Symbol() == "CHFJPY" || Symbol() == "CHFJPYm" ) { SymbolCode = 5000; }
   else if( Symbol() == "EURAUD" || Symbol() == "EURAUDm" ) { SymbolCode = 6000; }
   else if( Symbol() == "EURCAD" || Symbol() == "EURCADm" ) { SymbolCode = 7000; }
   else if( Symbol() == "EURCHF" || Symbol() == "EURCHFm" ) { SymbolCode = 8000; }
   else if( Symbol() == "EURGBP" || Symbol() == "EURGBPm" ) { SymbolCode = 9000; }
   else if( Symbol() == "EURJPY" || Symbol() == "EURJPYm" ) { SymbolCode = 1000; }
   else if( Symbol() == "EURUSD" || Symbol() == "EURUSDm" ) { SymbolCode = 1100; }
   else if( Symbol() == "GBPCHF" || Symbol() == "GBPCHFm" ) { SymbolCode = 1200; }
   else if( Symbol() == "GBPJPY" || Symbol() == "GBPJPYm" ) { SymbolCode = 1300; }
   else if( Symbol() == "GBPUSD" || Symbol() == "GBPUSDm" ) { SymbolCode = 1400; }
   else if( Symbol() == "NZDJPY" || Symbol() == "NZDJPYm" ) { SymbolCode = 1500; }
   else if( Symbol() == "NZDUSD" || Symbol() == "NZDUSDm" ) { SymbolCode = 1600; }
   else if( Symbol() == "USDCAD" || Symbol() == "USDCADm" ) { SymbolCode = 1700; }
   else if( Symbol() == "USDCHF" || Symbol() == "USDCHFm" ) { SymbolCode = 1800; }
   else if( Symbol() == "USDJPY" || Symbol() == "USDJPYm" ) { SymbolCode = 1900; }
                     
   
   //---- Period Code
   if( TimeSpecific )
   {
              if( Period() == 1 )    { PeriodCode = 10; }
         else if( Period() == 5 )    { PeriodCode = 20; }
         else if( Period() == 15 )   { PeriodCode = 30; }
         else if( Period() == 30 )   { PeriodCode = 40; }
         else if( Period() == 60 )   { PeriodCode = 50; }
         else if( Period() == 240 )  { PeriodCode = 60; }
         else if( Period() == 1440 ) { PeriodCode = 70; }
         else if( Period() == 10080 ){ PeriodCode = 80; }
   }
   else
   {
      PeriodCode = 0;
   }
   //---- Calculate MagicNumber
   MagicNumber = ExpertID+SymbolCode+PeriodCode;
   return(MagicNumber);
}

//+------------------------------------------------------------------+
//| Calculate Stop Long                                              |
//+------------------------------------------------------------------+
double StopLong(double price,int stop)
{
 if(stop==0)
 {
  return(0);
 }
 else
 {
  return(price-(stop*Point));
 }
}
//+------------------------------------------------------------------+
//| Calculate Stop Short                                             |
//+------------------------------------------------------------------+
double StopShort(double price,int stop)
{
 if(stop==0)
 {
  return(0);
 }
 else
 {
  return(price+(stop*Point));
 }
}
//+------------------------------------------------------------------+
//| Calculate Profit Target Long                                     |
//+------------------------------------------------------------------+
double TakeLong(double price,int take)
{
 if(take==0) {  return(0);}
 else        {  return(price+(take*Point));}
}
//+------------------------------------------------------------------+
//| Calculate Profit Target Short                                     |
//+------------------------------------------------------------------+
double TakeShort(double price,int take)
{
 if(take==0) {  return(0);}
 else        {  return(price-(take*Point));}
}
//+------------------------------------------------------------------+
//| Calculate concurrent Long position                               |
//+------------------------------------------------------------------+
int CountLongs(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if( OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber )
   continue;
   
  if(OrderType()==OP_BUY)
   count++;
 }//for
 return(count);
}
//+------------------------------------------------------------------+
//| Calculate concurrent short position                              |
//+------------------------------------------------------------------+
int CountShorts(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber )
   continue;
   
  if(OrderType()==OP_SELL)
  count++;
 }//for
 return(count);
}
//+------------------------------------------------------------------+
//| Close Long Position                                              |
//+------------------------------------------------------------------+
void CloseLongs(int MagicNumber)
{
 int i = OrdersTotal();
 
 while( CountLongs(MagicNumber) != 0 && i >= 0 )
 {  
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   
   if( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber )
   {
     i--;
     continue;
   }
   else if(OrderType()==OP_BUY || OrderType()== OP_BUYLIMIT)
   {
     OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,ExitLongColor);
     i--;
   }
 }
}
//+------------------------------------------------------------------+
//| Close Short Position                                             |
//+------------------------------------------------------------------+
void CloseShorts(int MagicNumber)
{
 int i = OrdersTotal();
 
 while( CountShorts(MagicNumber) != 0 && i >= 0 )
 {  
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   
   if( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber)
   {
     i--;
     continue;
   }
   else if(OrderType()== OP_SELL || OrderType()==OP_SELLLIMIT )
  {
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,ExitShortColor);
  }
 }
}
//+------------------------------------------------------------------+
//| Calculates Trailing Stops                                        |
//+------------------------------------------------------------------+
void TrailingAlls(int start,int stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0) return;
 
 int trade;
 // int trades=;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol())
   continue;

  if(OrderType()==OP_BUY)
  {
   profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Bid-(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,EnterLongColor);
  }//Long
  
  if(OrderType()==OP_SELL)
  {
   profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Ask+(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,EnterShortColor);
  }//Shrt
  
 }//for
}


